library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;

entity Counter is
    Port ( clk_in, en : in  STD_LOGIC;
           o : out STD_LOGIC_VECTOR(3 downto 0) :="0000";
			  tc : out STD_LOGIC := '0';
           reset : in  STD_LOGIC := '0';
			  clk_out : out STD_LOGIC);
end Counter;

architecture Behavioral of Counter is
	signal counter: unsigned(3 downto 0) :="0000";
	signal cnt_clk, clk_i: STD_LOGIC;
	
	component selectable_clock is
	Port ( clk : in std_logic;
	       s0 : in std_logic;
	       s1 : in std_logic;
	       out_clk : out std_logic);
	end component;
begin
	
	clk_div : selectable_clock
	port map(
		clk => clk_in,
		s0 => '1',
		s1 => '1',
		out_clk => clk_i);
	
	clk_out <= clk_i;
	cnt_clk <= clk_i and en;
	
	o <= std_logic_vector(counter);
	process(cnt_clk, reset)
	begin
		if rising_edge(cnt_clk) then
			if reset = '1' then
				counter <= "0000";
			elsif counter <= "1111" then
				counter <= counter + "0001";
			elsif counter = "1111" then
				counter <= "1111";
			end if;
		end if;
	end process;
	process(counter)
	begin
		if counter = "1111" then
			tc <= '1';
		else
			tc <= '0';
		end if;
	end process;
end Behavioral;

