----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    20:22:08 11/04/2014 
-- Design Name: 
-- Module Name:    adc - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity adc is
    Port ( clk : in  STD_LOGIC;
           da_out, result_out : out  STD_LOGIC_VECTOR (3 downto 0);
           done : out  STD_LOGIC;
           start_in : in  STD_LOGIC;
           comp : in  STD_LOGIC);
end adc;

architecture Behavioral of adc is
	component Counter is
	Port ( clk_in, en : in  STD_LOGIC;
           o : out STD_LOGIC_VECTOR(3 downto 0) :="0000";
			  tc : out STD_LOGIC := '0';
           reset : in  STD_LOGIC;
			  clk_out : out STD_LOGIC);
	end component;
	
	component debounce is
	Port ( input : in std_logic;
			clk_in : in std_logic;
			output : out std_logic);
	end component;
	
	signal r, cnt_clk, TC, c_en, start : STD_LOGIC;
	signal result : STD_LOGIC_VECTOR (3 downto 0);
	type state is (IDLE, COUNT);
	signal f, p : state;
begin

	da_out <= result;
	result_out <= result;

	cnt_0 : Counter
	port map(
		clk_in => clk,
		en => c_en,
		o => result,
		tc => TC,
		reset => r,
		clk_out => cnt_clk);
		
	deb_0 : debounce
	port map(
		input => start_in,
		clk_in => clk,
		output => start);
		

process (p, start, comp, cnt_clk, TC)
begin
	if rising_edge(cnt_clk) then
		p <= f;
	end if;
	
	case p is
		when IDLE =>
			if start = '1' then
				r <= '1';
				f <= COUNT;
				c_en <= '1';
				done <= '0';
			else
				r <= '0';
				f <= IDLE;
				c_en <= '0';
				done <= '1';
			end if;
		when COUNT =>
			if comp = '1' or TC = '1' then
				done <= '1';
				f <= IDLE;
				c_en <= '0';
			else
				f <= count;
			end if;
	end case;

end process;

end Behavioral;

